#ifndef ABBN_HEADER
#define ABBN_HEADER
#include <iostream>
#include <fstream>

#include <boost/function.hpp>

#include "format.hpp"

namespace abbn {
 struct header {
  char nam[10];
  char bib[5];
  int mf;
  int mt;
  double awr;
  double tem;
  int lv;
  int lt;
  int lc;
  int ls;
  fortran_format::ast lf;
 };

 extern const int* const structure;
 extern const int        ngroups;
 extern const int        mingroup;
 extern const int        maxgroup;

 int group(int wide_group, int narrow_group);
}

class iabbn: public std::ifstream {
 public: 

  fortran_format::reader reader1;
  fortran_format::reader reader2;
  fortran_format::reader reader;
  
  abbn::header h;

  iabbn();
  explicit iabbn(
    const char* filename, std::ios_base::openmode mode = ios_base::in
  );

  iabbn& next_line();
  iabbn& skip_comments();

  iabbn& read_header();
  bool find(boost::function<bool (abbn::header)> test);
  int read_group();

  template <typename T> iabbn& operator>>(T& x);
};

template <typename T> iabbn& iabbn::operator>>(T& x) {
 reader >> x;
 return *this;
};

#endif
