import patterns;
import graph;

real unit = 16cm/(6*5)/2;
unitsize(5*unit, 1*unit);

real l(real x) {
 real a = 5;
 real b = 0.3;
 real c = 3;
 real d = 20;
 real e = -1;
 return a/(b+(x-c)*(x-c))+d/(x-e);
};

real h(real x) {
 real a = 30;
 real b = -1;
 return a/(x-b);
};

real x0 = 1;
real y0 = 2;
real x = x0;
real dx = 0.01;
guide ph, pl;

while (x < 6) {
 ph = ph..(x,h(x));
 pl = pl..(x,l(x));
 x += dx;
};

draw(pl, linewidth(1.5pt));
draw(ph, linewidth(1.5pt));

real[] draw_line(real y) {
 pair[] p = intersectionpoints(pl, (0,y)--(6,y));
 real[] result;
 for (int i = 0; i < 2; ++i) {
  result[i] = intersect(ph, p[i]--(p[i].x,y0))[0];
  draw(p[i]--(p[i].x,y0));
 };
 draw((x0,y)--p[1]);
 return result;
};

real h[] = {16, 20};
real[] ts = draw_line(h[0]);
ts.append(draw_line(h[1]));
real x = ts[1];
ts[1] = ts[2];
ts[2] = x;

add("hatch", hatch(1mm));

pair[] centers;
for (int i = 0; i < 4; i += 2) {
 pair[] p = {point(ph, ts[i]), point(ph, ts[i+1])};
 fill(
  ((p[0].x,y0)--(p[1].x,y0)--p[1] & subpath(ph, ts[i+1], ts[i]))--cycle,
  pattern("hatch")
 );
 centers[round(i/2)] = midpoint(p[0]--(p[1].x,y0));
};

xaxis("$E$", YEquals(y0), Arrow);
yaxis(XEquals(x0), Arrow);

pair p_sigma_label_pos = (2.5,4);
pair phi_label_pos = (5.5,6);
pair sigma_label_pos = (1.5,9);

draw(centers[0]--p_sigma_label_pos--centers[1]);
label("$p(\sigma)\mathrm{d}\sigma$", p_sigma_label_pos,W);
draw(intersectionpoint(phi_label_pos--(phi_label_pos.x,0), ph)--phi_label_pos);
label("$\phi(E)$", phi_label_pos,N);
draw(
 intersectionpoint(sigma_label_pos--(sigma_label_pos.x,20), pl)--sigma_label_pos
);
label("$\sigma(E)$", sigma_label_pos,S);
label("$\sigma$", (x0,h[0]), W);
label("$\sigma+\mathrm{d}\sigma$", (x0,h[1]), W);
