#ifndef PADE_HEADER
#define PADE_HEADER

#ifdef DEBUG
#include <iostream>
#endif

#include "polynome.hpp"

class pade {
 public:
  polynome nominator, denominator;

  pade() {};
  pade(const pade& p): nominator(p.nominator), denominator(p.denominator) {};
  pade(double z, double c_2, double c_1);
  pade(double z, double c_2, double c_1, double c0, double c1);

  double operator()(double);

  static pade add_point(
    double c0, double c1,
    double znew, double zcurrent,
    const pade& current, const pade& previous
  );
};

#ifdef DEBUG
std::ostream& operator<<(std::ostream&, const pade&);
#endif

#endif
