#ifndef MY_PROGRAM_OPTIONS_H
#define MY_PROGRAM_OPTIONS_H

#include <boost/program_options.hpp>

struct my_option_description {
 const char* longname;
 const char shortname;
 const char* envname;
 boost::program_options::value_semantic* value;
 const char* description;
};

struct my_positional_option_description {
 const char* name;
 const char* envname;
 boost::program_options::value_semantic* value;
 int number;
};

boost::program_options::variables_map parse_args(
  int argc, char** argv,
  const my_option_description* desc,
  size_t descsize,
  const my_positional_option_description* posdesc = NULL,
  void (*usage)(const boost::program_options::options_description&) = NULL
);

#endif
